# Contributing

**Thanks for considering contributing to HistoQC!**

* [Code of conduct](#code-of-conduct)
* [I just want to ask a question!](#questions)
* [How can I contribute?](#how-can-i-contribute)
  * [Citing HistoQC](#citing-histoqc)
  * [Reporting bugs](#reporting-bugs)
  * [Supporting others](#supporting-others)
  * [Suggesting enhancements](#suggesting-enhancements)
  * [Working together](#working-together)
  * [Writing code](#writing-code)


## Code of conduct

This project is governed by its [Code of Conduct](CodeOfConduct.md). By participating, you're expected to uphold this code.


## Questions?

For questions and discussions, use the [issue tracker](https://github.com/choosehappy/HistoQC/issues).

You should also check out [the original blog post](http://www.andrewjanowczyk.com/histoqc-an-open-source-quality-control-tool-for-digital-pathology-slides/).


## How can I contribute?

### Citing HistoQC

If you use HistoQC in your research, please **cite the paper**:

_"HistoQC: An Open-Source Quality Control Tool for Digital Pathology Slides", Janowczyk A., Zuo R., Gilmore H., Feldman M., Madabhushi A., JCO Clinical Cancer Informatics, 2019_ [[Link]](https://pubmed.ncbi.nlm.nih.gov/30990737/)

Writing and supporting this tool takes _a lot_ of time. So whenever you use any software for research, please remember to check how it should be cited!


### Reporting bugs

If you find a bug, you can report it [here](https://github.com/choosehappy/HistoQC/issues).

### Supporting others

#### Answering questions
The issue tracker isn't just a good place for asking questions - it's a good place for answering them too.

It's _enormously helpful_ when users of the software answer one another's questions rather than leaving it up to the developer... and it's a good way to learn as well.

#### Creating documentation
Figured out how to do something, and want to spare others the time it took?

Tutorials, tweetorials, blog posts and videos can all help add to the community documentation. [Wiki entries](https://github.com/choosehappy/HistoQC/wiki) and [blog posts](http://www.andrewjanowczyk.com/histoqc-an-open-source-quality-control-tool-for-digital-pathology-slides/) help spread the love!


### Suggesting enhancements

The [issue tracker](https://github.com/choosehappy/HistoQC/issues) is also a good place to suggest enhancements to HistoQC

Please be aware that there are enhancements planned already - you should vote or comment on any suggestions or feedback you have.


### Working together

HistoQC is being developed at Case Western Reserve University. 
Ways to contribute (other than forking this repository) include [joining Andrew's group](http://ccipd.case.edu), as well as collaborating on research projects and methods that can be integrated back into HistoQC for everyone to use.

Contact Andrew at andrew.janowczyk@case.edu if you are interested in further discussions!

### Writing code

#### Pull requests

You can also contribute by submitting pull requests to HistoQC itself.

It would be _much appreciated_ if you discuss any proposed changes first [the issue tracker](https://github.com/choosehappy/HistoQC/issues). It may be that someone is already working on what you'd like to change, or it might not be compatible with some other work-in-progress.

In accordance with [GitHub's Terms of Service](https://help.github.com/en/articles/github-terms-of-service#6-contributions-under-repository-license), any contributions you _do_ make are under the [same license as HistoQC](LICENSE.md). Please make sure you have the rights for any code that you contribute, and you attribute any dependencies appropriately.

These guidelines were adapted from [QuPath](https://github.com/qupath/qupath/blob/master/CONTRIBUTING.md).
